/**
 * Simulation of memory management algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#include "FirstFit.h"

bool FirstFit::find_hole(const string id, const int size)
{
    // Start searching from the start of the segment list
    // for any sufficiently large hole.
    for (segment_list_iterator = segment_list.begin();
         segment_list_iterator != segment_list.end();
         segment_list_iterator++)
    {
        Segment *segment = *segment_list_iterator;

        // First fit search.
        if (segment->size < 0)
        {
            int extra = size + segment->size;
            if (extra <= 0) return true;  // found a hole big enough
        }
    }

    return false;
}
